%define debug_package %{nil}
%define _build_id_links none
%define python_version 3.8
%global __os_install_post /usr/lib/rpm/brp-compress %{nil}

Name:       orange3
Version:    3.31.1
Release:    3%{?dist}
Summary:    Python GUI Data Mining Tool

License:    GPLv3+
URL:        https://orangedatamining.com/
AutoReqProv: no
Source0:    https://github.com/biolab/orange3/archive/stable.tar.gz#/%{name}-%{version}.tar.gz
BuildRequires:  python%{python_version}
BuildRequires: pkgconfig(python-%{python_version}) >= %{python_version}
BuildRequires: postgresql-devel mysql-devel
BuildRequires: gcc-c++ cyrus-sasl-devel
BuildRequires: postgresql-devel
BuildRequires: perl-interpreter findutils
BuildRequires: git
BuildRequires: systemd-rpm-macros python-rpm-macros
BuildRequires: /usr/bin/pathfix.py
BuildRequires: desktop-file-utils

Requires: python%{python_version}
Requires: pkgconfig(python-%{python_version}) == %{python_version}
Requires:   postgresql-libs postgresql 
Requires(pre): /usr/sbin/useradd, /usr/bin/getent
Requires(postun): /usr/sbin/userdel

%description
Open source machine learning and data visualization.
Build data analysis workflows visually, with a large, diverse toolbox.

%prep
rm -rf %{_builddir}/%{name}/
%setup -q -b 0 -n %{name}-stable

%build
rm -rf $RPM_BUILD_ROOT

%install
mkdir -p ${RPM_BUILD_ROOT}/opt/%{name}/
mkdir -p ${RPM_BUILD_ROOT}/%{_datadir}/applications/

cp -r * ${RPM_BUILD_ROOT}/opt/%{name}/
cd ${RPM_BUILD_ROOT}/opt/%{name}/
python%{python_version} -m venv ${RPM_BUILD_ROOT}/opt/%{name}/
${RPM_BUILD_ROOT}/opt/%{name}/bin/pip install . psycopg2-binary pymssql

# install desktop file
cat << EOF > ${RPM_BUILD_ROOT}/%{_datadir}/applications/%{name}.desktop
[Desktop Entry]
Type=Application
Name=Orange Data Mining
Comment=Graphical Data Mining Tool
Icon=/opt/orange3/distribute/icon-256.png
Exec=/opt/%{name}/bin/orange-canvas
Terminal=false
Categories=Utility;Office;Spreadsheet;
EOF

desktop-file-validate %{buildroot}/%{_datadir}/applications/%{name}.desktop

# strip rpmbuildroot paths
grep -lrZF "#!$RPM_BUILD_ROOT" $RPM_BUILD_ROOT | xargs -r -0 perl -p -i -e "s|$RPM_BUILD_ROOT||g"
find $RPM_BUILD_ROOT -type f -regex '.*egg-link$' |xargs -I% grep -lrZF "$RPM_BUILD_ROOT" % | xargs -r -0 perl -p -i -e "s|$RPM_BUILD_ROOT||g"
grep -lrZF "$RPM_BUILD_ROOT" $RPM_BUILD_ROOT/opt/%{name}/bin/ | xargs -r -0 perl -p -i -e "s|$RPM_BUILD_ROOT||g"
grep -lrZF "$RPM_BUILD_ROOT" $RPM_BUILD_ROOT/opt/%{name}/lib/python%{python_version}/site-packages/Orange3-%{version}.dist-info/ | xargs -r -0 perl -p -i -e "s|$RPM_BUILD_ROOT||g"


# cleanup
find ${RPM_BUILD_ROOT} -regex '.*\.pyc$' -exec rm '{}' ';'
find ${RPM_BUILD_ROOT} -regex '.*\.pyo$' -exec rm '{}' ';'

%py3_shebang_fix $RPM_BUILD_ROOT/opt/%{name}/

export QA_RPATHS=$(( 0x0002 ))

%post
/opt/%{name}/venv/bin/python -m compileall -q /opt/%{name}/ > /dev/null 2>&1 
/usr/bin/systemctl daemon-reload

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644, root, root ,755)
/opt/%{name}/
%attr(755, root, root) /opt/%{name}/bin/*
%{_datadir}/applications/%{name}.desktop

%changelog
* Sat May 08 2021 Izhar Firdaus <kagesenshi.87@gmail.com> 1.1.0-3
- fix cython dep issue in CentOS (kagesenshi.87@gmail.com)

* Fri May 07 2021 Izhar Firdaus <kagesenshi.87@gmail.com> 1.1.0-2
- use releasetagger (kagesenshi.87@gmail.com)
- bump version to 1.1.0 (kagesenshi.87@gmail.com)
- configure thumbnail caching with redis (kagesenshi.87@gmail.com)
- added tito release config (kagesenshi.87@gmail.com)
- bump superset version (kagesenshi.87@gmail.com)
- fix ownership config (kagesenshi.87@gmail.com)
- package is now managed using tito (kagesenshi.87@gmail.com)

* Mon Feb 08 2021 Izhar Firdaus <kagesenshi.87@gmail.com> 1.0.0-1
- new package built with tito

* Thu Feb 4 2021 Izhar Firdaus - 1.0.0
- initial package
